[leetcode] 1035. Uncrossed Lines

Description

We write the integers of A and B (in the order they are given) on two separate horizontal lines.

Now, we may draw connecting lines: a straight line connecting two numbers A[i] and B[j] such that:

  • A[i] == B[j];
  • The line we draw does not intersect any other connecting (non-horizontal) line.

Note that a connecting lines cannot intersect even at the endpoints: each number can only belong to one connecting line.

Return the maximum number of connecting lines we can draw in this way.

Example 1:

Input: A = [1,4,2], B = [1,2,4]
Output: 2
Explanation: We can draw 2 uncrossed lines as in the diagram.
We cannot draw 3 uncrossed lines, because the line from A[1]=4 to B[2]=4 will intersect the line from A[2]=2 to B[1]=2.

Example 2:

Input: A = [2,5,1,2,5], B = [10,5,2,1,5,2]
Output: 3

Example 3:

Input: A = [1,3,7,1,7,5], B = [1,9,2,5,1]
Output: 2

Note:

  1. 1 <= A.length <= 500.
  2. 1 <= B.length <= 500.
  3. 1 <= A[i], B[i] <= 2000.

分析

题目的意思是:给定两个数组,给相同的数连上线,要求不能够交叉,我左思右想没想出来,所以借鉴了一下别人的dp的思路,dp[i][j]代表数组A前i个元素和数组B前j个元素的最大连线数,然后这个问题就变成了类似求最长公共子序列的问题了,dp方法要注意初始化和边界问题就行了。

代码

class Solution:
    def maxUncrossedLines(self, A: List[int], B: List[int]) -> int:
        m=len(A)
        n=len(B)
        dp=[[0 for _ in range(n+1)] for _ in range(m+1)]
        for i in range(1,m+1):
            for j in range(1,n+1):
                if(A[i-1]==B[j-1]):
                    dp[i][j]=dp[i-1][j-1]+1
                else: 
                    dp[i][j]=max(dp[i][j-1],dp[i-1][j])
        return dp[m][n]
        

参考文献

[LeetCode] Python by O( m*n ) DPw/ Graph

你可能感兴趣的:(python,leetcode题解)